blob: da9947b961de5beb7a2d011c619d22812ccdc123 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
Stefan Reinauer074d9132009-09-26 16:43:17 +000018
Stefan Reinauerd7649122015-06-09 11:44:25 -070019cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010020
Martin Roth2ab981b2016-08-31 16:43:49 -060021CROSSGCC_DATE="August 31st, 2016"
22CROSSGCC_VERSION="1.43"
Stefan Reinauer88352d72016-04-06 15:57:03 -070023CROSSGCC_COMMIT=$( git describe )
Stefan Reinauer074d9132009-09-26 16:43:17 +000024
25# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070026PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070027TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000028TARGETARCH=i386-elf
Nico Huber32c4a062016-01-25 18:30:57 +010029LANGUAGES=c
Stefan Reinauer074d9132009-09-26 16:43:17 +000030DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070031SAVETEMPS=0
32SKIPPYTHON=1
Nico Huber234d2462016-01-26 16:10:17 +010033BOOTSTRAP=0
Stefan Reinauer074d9132009-09-26 16:43:17 +000034
Stefan Reinauer699ac272015-06-05 12:43:28 -070035# GCC toolchain version numbers
Timothy Pearson96310162015-12-28 22:53:29 -060036GMP_VERSION=6.1.0
Iru Caiae8e3a02016-04-02 10:50:59 +080037MPFR_VERSION=3.1.4
Paul Menzele6619422015-02-23 10:33:59 +010038MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000039LIBELF_VERSION=0.8.13
Iru Caiae8e3a02016-04-02 10:50:59 +080040GCC_VERSION=5.3.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070041GCC_AUTOCONF_VERSION=2.69
Martin Rothbcfa7cc2016-07-14 13:01:37 -060042BINUTILS_VERSION=2.26.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070043GDB_VERSION=7.11
Martin Roth2ab981b2016-08-31 16:43:49 -060044IASL_VERSION=20160831
Stefan Reinauer3dc5d072016-04-21 19:29:03 -070045PYTHON_VERSION=3.5.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070046EXPAT_VERSION=2.1.1
Stefan Reinauer14ce2132015-06-05 13:01:13 -070047# CLANG version number
Iru Caiae8e3a02016-04-02 10:50:59 +080048CLANG_VERSION=3.8.0
Martin Roth589ef9d2016-08-11 18:35:06 -060049MAKE_VERSION=4.2.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000050
Stefan Reinauer699ac272015-06-05 12:43:28 -070051# GCC toolchain archive locations
Martin Roth1484c032016-03-08 09:37:14 -070052# These are sanitized by the jenkins toolchain test builder, so if
53# a completely new URL is added here, it probably needs to be added
54# to the jenkins build as well, or the builder won't download it.
Stefan Reinauerd9d21022016-04-21 18:16:30 -070055GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}.tar.xz"
56MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.xz"
Idwer Vollering7962fc72012-10-25 02:14:09 +020057MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000058LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020059GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070060BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010061GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
Patrick Georgi85bb9462016-02-11 17:22:16 +010062IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix2-${IASL_VERSION}.tar.gz"
Patrick Georgi53c388f2015-03-07 09:55:18 +010063PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer498f3d02016-04-21 18:10:15 -070064EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.bz2"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070065# CLANG toolchain archive locations
66LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
67CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
68CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
69CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080070MAKE_ARCHIVE="http://ftpmirror.gnu.org/make/make-${MAKE_VERSION}.tar.bz2"
Stefan Reinauer074d9132009-09-26 16:43:17 +000071
Martin Roth58c68d52016-03-01 15:22:42 -070072ALL_ARCHIVES="$GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
73 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $IASL_ARCHIVE \
74 $PYTHON_ARCHIVE $EXPAT_ARCHIVE $LLVM_ARCHIVE $CFE_ARCHIVE \
75 $CRT_ARCHIVE $CTE_ARCHIVE $MAKE_ARCHIVE"
76
Stefan Reinauer699ac272015-06-05 12:43:28 -070077# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000078GMP_DIR="gmp-${GMP_VERSION}"
79MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000080MPC_DIR="mpc-${MPC_VERSION}"
81LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000082GCC_DIR="gcc-${GCC_VERSION}"
83BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
84GDB_DIR="gdb-${GDB_VERSION}"
Patrick Georgi85bb9462016-02-11 17:22:16 +010085IASL_DIR="acpica-unix2-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010086PYTHON_DIR="Python-${PYTHON_VERSION}"
87EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070088# CLANG toolchain directories
89LLVM_DIR="llvm-${CLANG_VERSION}.src"
90CFE_DIR="cfe-${CLANG_VERSION}.src"
91CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
92CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080093MAKE_DIR="make-${MAKE_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000094
Patrick Georgi6321f522015-02-27 23:36:26 +010095unset MAKELEVEL MAKEFLAGS
96
Patrick Georgi1861ff72011-10-31 12:15:55 +010097red='\033[0;31m'
98RED='\033[1;31m'
99green='\033[0;32m'
100GREEN='\033[1;32m'
101blue='\033[0;34m'
102BLUE='\033[1;34m'
103cyan='\033[0;36m'
104CYAN='\033[1;36m'
105NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +0000106
zbaoe05c1ea2015-08-05 23:10:05 -0400107UNAME=$(uname | grep -iq cygwin && echo Cygwin || uname)
Martin Roth88463822016-01-07 11:03:36 -0700108HALT_FOR_TOOLS=0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700109
Patrick Georgi198d23c2012-12-08 08:02:44 +0100110normalize_dirs()
111{
112 mkdir -p $DESTDIR$TARGETDIR/lib
113 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
114 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
115 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
116
117 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
118 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
119}
120
Stefan Reinauer93a96302015-06-15 12:36:53 -0700121please_install()
122{
Martin Roth88463822016-01-07 11:03:36 -0700123 HALT_FOR_TOOLS=1
Patrick Georgi5da95dc2015-07-17 23:33:05 +0200124 test -r /etc/os-release && . /etc/os-release
Stefan Reinauer93a96302015-06-15 12:36:53 -0700125 case "$ID_LIKE" in
126 debian) solution="sudo apt-get install $1" ;;
127 suse) solution="sudo zypper install $1" ;;
128 *) solution="using your OS packaging system" ;;
129 esac
130
Martin Roth591790f2016-03-20 20:39:04 -0600131 printf "${RED}ERROR:${red} Missing tool: Please install \'$1\'. (eg $solution)${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700132 if [ -n "$2" ]; then
Martin Roth591790f2016-03-20 20:39:04 -0600133 printf "${RED}ERROR:${red} or install \'$2\'.${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700134 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700135}
136
Patrick Georgib7062882015-02-24 10:52:14 +0100137searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000138{
139 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100140 # $2 search string
141 # $3 soft fail if set
Martin Rothe3963172016-01-06 13:54:32 -0700142 # $4 alternative package to install on failure
Patrick Georgib7062882015-02-24 10:52:14 +0100143 # result: file name of that tool on stdout
144 # or no output if nothing suitable was found
145 search=GNU
146 if [ -n "$2" ]; then
147 search="$2"
148 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000149 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700150 if [ -x "$(which $i 2>/dev/null)" ]; then
151 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
152 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000153 echo $i
154 return
155 fi
156 fi
157 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800158 # A workaround for OSX 10.9 and some BSDs, whose nongnu
159 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200160 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100161 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700162 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800163 echo $1
164 return
165 fi
166 fi
167 fi
zbao5cf758d2015-09-01 22:28:57 -0400168 if echo $1 | grep -q "sum" ; then
169 algor=$(echo $1 | sed -e 's,sum,,')
170 if [ -x "$(which $1 2>/dev/null)" ]; then
171 #xxxsum [file]
172 echo $1
173 return
174 elif [ -x "$(which $algor 2>/dev/null)" ]; then
175 #xxx [file]
176 echo $algor
177 return
178 elif [ -x "$(which openssl 2>/dev/null)" ]; then
179 #openssl xxx [file]
180 echo openssl $algor
181 return
182 elif [ -x "$(which cksum 2>/dev/null)" ]; then
183 #cksum -a xxx [file]
184 #cksum has special options in NetBSD. Actually, NetBSD will use the second case above.
185 echo "buildgcc" | cksum -a $algor > /dev/null 2>/dev/null && \
186 echo cksum -a $algor
187 return
zbao939dc842015-04-30 04:44:07 +0800188 fi
189 fi
Martin Rothe3963172016-01-06 13:54:32 -0700190
Martin Roth88463822016-01-07 11:03:36 -0700191 [ -z "$3" ] && please_install $1 $4
Patrick Georgib7062882015-02-24 10:52:14 +0100192 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000193}
194
Martin Roth591790f2016-03-20 20:39:04 -0600195# Run a compile check of the specified library option to see if it's installed
196check_for_library() {
197 local LIBRARY_FLAGS=$1
Aaron Durbin0ac4e5a2016-04-07 16:56:25 -0500198 local LIBRARY_PACKAGES="$2"
Martin Roth591790f2016-03-20 20:39:04 -0600199 local LIBTEST_FILE=.libtest
200
201 echo "int main(int argc, char **argv) { (void) argc; (void) argv; return 0; }" > "${LIBTEST_FILE}.c"
202
203 cc $CFLAGS $LIBRARY_FLAGS "${LIBTEST_FILE}.c" -o "${LIBTEST_FILE}" >/dev/null 2>&1 || \
204 please_install "$LIBRARY_PACKAGES"
205 rm -rf "${LIBTEST_FILE}.c" "${LIBTEST_FILE}"
206}
207
Nico Huberaee7f462016-09-20 12:55:19 +0200208buildcc_major() {
209 echo "${GCC_VERSION}" | cut -d. -f1
210}
211
212buildcc_version() {
213 echo "${GCC_VERSION}" | cut -d. -f1-2
214}
215
216hostcc_major() {
217 (echo __GNUC__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
218}
219
220hostcc_minor() {
221 (echo __GNUC_MINOR__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
222}
223
224hostcc_version() {
225 printf "%d.%d" "$(hostcc_major)" "$(hostcc_minor)"
226}
227
Nico Huber75797162016-09-20 13:01:57 +0200228hostcc_has_gnat1() {
229 [ -x "$(${CC} -print-prog-name=gnat1)" ]
230}
231
232ada_requested() {
233 echo "${LANGUAGES}" | grep -q '\<ada\>'
234}
235
236check_gnat() {
237 if hostcc_has_gnat1; then
238 if [ "$(hostcc_version)" != "$(buildcc_version)" -a "${BOOTSTRAP}" != "1" ]; then
239 printf "\n${RED}ERROR:${red} Building the Ada compiler (gnat $(buildcc_version)) "
240 printf "with a different host compiler\n version ($(hostcc_version)) "
241 printf "requires bootstrapping (-b).${NC}\n\n"
242 HALT_FOR_TOOLS=1
243 fi
244 fi
245}
246
Nico Huber156d87c2016-09-20 12:59:53 +0200247check_cc() {
248 if is_package_enabled "GCC"; then
249 if [ "$(hostcc_major)" != "$(buildcc_major)" -a "${BOOTSTRAP}" != "1" ]; then
250 printf "\n${red}warning: Building GCC $(buildcc_version) with a different major "
251 printf "version ($(hostcc_version)).\n"
252 printf " Bootstrapping (-b) is recommended.${NC}\n\n"
253 fi
Nico Huber75797162016-09-20 13:01:57 +0200254 if ada_requested; then
255 check_gnat
256 fi
Nico Huber156d87c2016-09-20 12:59:53 +0200257 fi
258}
259
zbao06e85ac2015-08-24 22:08:36 -0400260check_sum() {
261 test -z "$CHECKSUM" || \
262 test "$(cat sum/$1.cksum 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')" = \
263 "$($CHECKSUM tarballs/$1 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')"
264}
265
266compute_sum() {
267 test ! -f sum/$1.cksum && test -f tarballs/$1 && \
268 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$1 > sum/$1.cksum ) && \
269 printf "(checksum created. ${RED}Note. Please upload sum/$1.cksum if the corresponding archive is upgraded.)${NC}"
270}
271
zbao282dd952015-09-06 05:00:04 -0400272download_showing_percentage() {
273 url=$1
274 printf " ..${red} 0%%"
275 wget --no-check-certificate $url 2>&1 | while read line; do
zbao282dd952015-09-06 05:00:04 -0400276 echo $line | grep -o "[0-9]\+%" | awk '{printf("\b\b\b\b%4s", $1)}'
zbao282dd952015-09-06 05:00:04 -0400277 done
Zheng Baobb003c82016-08-05 13:41:51 +0800278 printf "${NC}"
zbao282dd952015-09-06 05:00:04 -0400279}
280
Stefan Reinauer88935482015-06-05 09:51:10 -0700281download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700282 package=$1
283 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700284
Stefan Reinauerd7649122015-06-09 11:44:25 -0700285 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700286 printf " * $FILE "
287
zbaod22b9ea2015-08-30 23:35:16 -0400288 if test -f tarballs/$FILE && check_sum $FILE ; then
289 printf "(cached)"
290 else
Paul Menzelb2ba3952015-06-12 11:58:14 +0200291 printf "(downloading from $archive)"
Stefan Reinauer88935482015-06-05 09:51:10 -0700292 rm -f tarballs/$FILE
293 cd tarballs
zbao282dd952015-09-06 05:00:04 -0400294 download_showing_percentage $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700295 cd ..
zbao06e85ac2015-08-24 22:08:36 -0400296 compute_sum $FILE
zbaod22b9ea2015-08-30 23:35:16 -0400297 fi
298
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700299 if [ ! -f tarballs/$FILE ]; then
zbao282dd952015-09-06 05:00:04 -0400300 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700301 exit 1
302 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700303 printf "\n"
304}
305
306unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700307 package=$1
308 archive="$(eval echo \$$package"_ARCHIVE")"
309 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700310 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700311 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700312 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700313 suffix=$(echo $archive | sed 's,.*\.,,')
Martin Roth95f7b222016-03-20 12:38:48 -0600314 if [ "$suffix" = "gz" ] && [ -n "$PIGZ" ]; then FLAGS="-I pigz -xf"
315 elif [ "$suffix" = "gz" ]; then FLAGS=zxf
316 elif [ "$suffix" = "bz2" ] && [ -n "$LBZIP2" ]; then FLAGS="-I lbzip2 -xf"
317 elif [ "$suffix" = "bz2" ]; then FLAGS=jxf
318 elif [ "$suffix" = "xz" ]; then FLAGS="--xz -xf"
319 elif [ "$suffix" = "lzma" ]; then FLAGS="--lzma -xf"
320 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700321 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700322 for patch in patches/${dir}_*.patch; do
323 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700324 printf " o $(basename $patch)\n"
Nico Huber4b48ed82016-07-27 00:28:03 +0200325 (cd ${dir} && $PATCH -s -N -p1 <../${patch}) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700326 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700327 exit 1
328 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700329 done
330 touch ${dir}/.unpack_success
331 )
332}
333
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700334fn_exists()
335{
Patrick Georgic8665912015-06-11 21:04:31 +0200336 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100337}
338
Patrick Georgif2c15f52015-06-11 21:07:31 +0200339is_package_enabled()
340{
341 echo "$PACKAGES" |grep -q "\<$1\>"
342}
343
Martin Roth444ece22016-04-01 18:46:29 -0600344package_uses_targetarch()
345{
Stefan Reinauera344b682016-04-21 19:29:51 -0700346 if [ "$1" = "GCC" ] || [ "$1" = "GDB" ] || [ "$1" = "BINUTILS" ]; then
Martin Roth444ece22016-04-01 18:46:29 -0600347 true
348 else
349 false
350 fi
351}
352
Nico Huber11ea2b32016-01-26 16:09:31 +0100353generic_build()
354{
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700355 package=$1
Nico Huber11ea2b32016-01-26 16:09:31 +0100356 host_target=$2
357 builddir=$3
358 success=$4
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700359
360 fn_exists build_$package || return
361
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700362 version="$(eval echo \$$package"_VERSION")"
Stefan Reinauer05bbc9202015-06-09 12:21:42 -0700363
Nico Huber11ea2b32016-01-26 16:09:31 +0100364 mkdir -p "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700365
Nico Huber11ea2b32016-01-26 16:09:31 +0100366 if [ -f "$success" ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700367 printf "Skipping $package as it is already built\n"
368 else
369 printf "Building $package $version ... "
Nico Huber11ea2b32016-01-26 16:09:31 +0100370 DIR="$PWD"
371 cd "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700372 rm -f .failed
Nico Huber11ea2b32016-01-26 16:09:31 +0100373 build_${package} $host_target > build.log 2>&1
374 cd "$DIR"
375 if [ ! -f "$builddir/.failed" ]; then
376 touch "$success";
377 else
378 printf "${RED}failed${NC}. Check $builddir/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700379 exit 1
380 fi
381 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700382 fi
383}
384
Nico Huber11ea2b32016-01-26 16:09:31 +0100385build_for_host()
386{
387 generic_build $1 host build-$1 "${TARGETDIR}/.$1.success"
388}
389
390build_for_target()
391{
392 generic_build $1 target build-${TARGETARCH}-$1 "${TARGETDIR}/.${TARGETARCH}-$1.success"
393}
394
395build()
396{
397 if package_uses_targetarch $1; then
Nico Huber234d2462016-01-26 16:10:17 +0100398 if [ $BOOTSTRAP -eq 1 -a ! -f "${TARGETDIR}/.GCC.success" ]; then
399 build_for_host GCC
400 fi
Nico Huber11ea2b32016-01-26 16:09:31 +0100401 build_for_target $1
402 else
403 build_for_host $1
404 fi
405}
406
Zheng Baobb003c82016-08-05 13:41:51 +0800407quit()
408{
409 printf "${NC}Stop\n"
410 exit 1
411}
412
Stefan Reinauer074d9132009-09-26 16:43:17 +0000413cleanup()
414{
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700415 if [ $SAVETEMPS -ne 0 ]; then
416 printf "Leaving temporary files around... ${green}ok${NC}\n"
417 return
418 fi
419
Stefan Reinauer074d9132009-09-26 16:43:17 +0000420 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700421 for package in $PACKAGES; do
Martin Roth444ece22016-04-01 18:46:29 -0600422 rm -rf build-${TARGETARCH}-$package build-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700423 done
zbaoff3f15c2015-08-26 22:00:31 -0400424 rm -f getopt
Stefan Reinauer074d9132009-09-26 16:43:17 +0000425 printf "${green}ok${NC}\n"
426}
427
428myhelp()
429{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700430 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000431 printf " $0 [-V|--version]\n"
432 printf " $0 [-h|--help]\n\n"
433
434 printf "Options:\n"
435 printf " [-V|--version] print version number and exit\n"
436 printf " [-h|--help] print this help and exit\n"
437 printf " [-c|--clean] remove temporary files before build\n"
438 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100439 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Nico Huber152e78e2016-09-20 15:38:40 +0200440 printf " [-n|--nocolor] don't print color codes in output\n"
441 printf " [-u|--urls] print the urls for all packages\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000442 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600443 printf " [-s]--supported <tool> print supported version of a tool\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000444 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600445 printf " (defaults to $TARGETDIR)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000446 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100447 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700448 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
449 printf " (defaults to $PACKAGE)\n"
450 printf "GCC specific options:\n"
Nico Huber234d2462016-01-26 16:10:17 +0100451 printf " [-b|--bootstrap] bootstrap the host compiler before building\n"
452 printf " the cross compiler\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700453 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
454 printf " (defaults to $TARGETARCH)\n"
Nico Huberbb313bf2015-09-08 12:30:27 +0200455 printf " [-l|--languages <languages>] comma separated list of target languages\n"
456 printf " (defaults to $LANGUAGES)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700457 printf "GDB specific options:\n"
458 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
459 printf " (defaults to $TARGETARCH)\n"
460 printf " [-S|--scripting] build scripting support for GDB\n\n"
Martin Rothd1da74f2015-06-21 12:06:28 -0600461 printf "Platforms for GCC & GDB:\n"
Martin Roth3e0f74d2016-03-08 12:07:04 -0700462 printf " x86_64 i386-elf i386-mingw32 mipsel-elf riscv-elf arm aarch64\n"
Jonathan Neuschäferf14f6402016-03-11 20:22:23 +0100463 printf " powerpc64le-linux-gnu nds32le-elf\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000464}
465
Martin Rothedf965a2015-11-25 16:58:33 -0700466printversion() {
467 printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
468}
469
Stefan Reinauer074d9132009-09-26 16:43:17 +0000470myversion()
471{
Martin Rothedf965a2015-11-25 16:58:33 -0700472 printversion
Stefan Reinauer074d9132009-09-26 16:43:17 +0000473
474 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000475Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600476Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000477
478This program is free software; you can redistribute it and/or modify
479it under the terms of the GNU General Public License as published by
480the Free Software Foundation; version 2 of the License.
481
482This program is distributed in the hope that it will be useful,
483but WITHOUT ANY WARRANTY; without even the implied warranty of
484MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
485GNU General Public License for more details.
486
487EOF
488}
489
Nico Huber5f72f962016-01-31 23:05:19 +0100490have_hostcflags_from_gmp() {
491 grep -q __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h >/dev/null 2>&1
492}
493
494set_hostcflags_from_gmp() {
495 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
496 # as GCC 4.6.x fails if it's there.
Idwer Volleringba349ab2016-07-24 02:10:19 +0200497 export HOSTCFLAGS="$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
498 sed s,-pedantic,,)"
Nico Huber5f72f962016-01-31 23:05:19 +0100499}
500
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700501build_GMP() {
Paul Kocialkowski7899db22016-06-17 21:41:00 -0700502 CC="$CC" ../${GMP_DIR}/configure --disable-shared --enable-fat \
Nico Huber5f72f962016-01-31 23:05:19 +0100503 --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700504 || touch .failed
505 $MAKE $JOBS || touch .failed
506 $MAKE install DESTDIR=$DESTDIR || touch .failed
507
508 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700509
Nico Huber5f72f962016-01-31 23:05:19 +0100510 set_hostcflags_from_gmp
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700511}
512
513build_MPFR() {
514 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
515 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
516 --infodir=$TARGETDIR/info \
517 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
518 touch .failed
519 $MAKE $JOBS || touch .failed
520 $MAKE install DESTDIR=$DESTDIR || touch .failed
521
522 normalize_dirs
523
524 # work around build problem of libgmp.la
525 if [ "$DESTDIR" != "" ]; then
526 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
527 fi
528}
529
530build_MPC() {
531 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
532 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
533 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
534 touch .failed
535 $MAKE $JOBS || touch .failed
536 $MAKE install DESTDIR=$DESTDIR || touch .failed
537
538 normalize_dirs
539}
540
541build_LIBELF() {
542 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
543 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
544 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
545 $MAKE $JOBS || touch .failed
546 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
547
548 normalize_dirs
549}
550
551build_BINUTILS() {
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700552 if [ $TARGETARCH == "x86_64-elf" ]; then
553 ADDITIONALTARGET=",i386-elf"
554 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700555 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700556 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
557 --disable-werror --disable-nls --enable-lto --enable-gold \
Stefan Reinauer2fe2d3d2016-04-05 02:14:48 -0700558 --enable-interwork --enable-multilib \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700559 --enable-plugins --enable-multilibs CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700560 $MAKE $JOBS || touch .failed
561 $MAKE install DESTDIR=$DESTDIR || touch .failed
562}
563
Nico Huber234d2462016-01-26 16:10:17 +0100564bootstrap_GCC() {
565 CC="$CC" \
566 CFLAGS="$HOSTCFLAGS" \
567 CFLAGS_FOR_BUILD="$HOSTCFLAGS" \
568 CFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
569 CXXFLAGS="$HOSTCFLAGS" \
570 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" \
571 CXXFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
572 ../gcc-${GCC_VERSION}/configure \
573 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
574 --enable-bootstrap \
575 --disable-werror --disable-nls \
576 --disable-shared --disable-multilib \
577 --disable-libssp --disable-libquadmath --disable-libcc1 \
578 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
579 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
580 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
581 --with-pkgversion="coreboot bootstrap v$CROSSGCC_VERSION $CROSSGCC_DATE" \
582 && \
583 $MAKE $JOBS BOOT_CFLAGS="$HOSTCFLAGS" BUILD_CONFIG="" bootstrap && \
584 $MAKE install-gcc \
585 install-target-libgcc \
586 maybe-install-target-libada \
587 maybe-install-target-libstdc++-v3 \
588 DESTDIR=$DESTDIR && \
589 ln -s gcc $DESTDIR$TARGETDIR/bin/cc || touch .failed
590}
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700591
Nico Huber234d2462016-01-26 16:10:17 +0100592build_cross_GCC() {
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700593 # Work around crazy code generator in GCC that confuses CLANG.
Aaron Durbinb2229dc2016-04-07 16:58:10 -0500594 $CC --version | grep clang >/dev/null 2>&1 && \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700595 HOSTCFLAGS="$HOSTCFLAGS -fbracket-depth=1024"
596
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700597 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
598 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700599 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
600 # but it does not seem to work properly. At least the host library
601 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700602 # Also set the CXX version of the flags because GCC is now compiled
603 # using C++.
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100604 CC="$CC" CFLAGS_FOR_TARGET="-O2 -Dinhibit_libc" CFLAGS="$HOSTCFLAGS" \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700605 CFLAGS_FOR_BUILD="$HOSTCFLAGS" CXXFLAGS="$HOSTCFLAGS" \
606 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700607 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
608 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700609 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700610 --disable-libssp --disable-bootstrap --disable-nls \
611 --disable-libquadmath --without-headers \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100612 --disable-threads \
Patrick Georgi1fc02d12016-03-23 21:44:43 +0100613 --enable-interwork --enable-multilib --enable-targets=all \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100614 --disable-libatomic --disable-libcc1 --disable-decimal-float \
Nico Huberbb313bf2015-09-08 12:30:27 +0200615 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
Ronald G. Minnich7ee16b72016-02-12 21:54:59 +0000616 --with-system-zlib \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700617 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
618 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
619 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
620 || touch .failed
621 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
622 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
623
Stefan Reinauerd7649122015-06-09 11:44:25 -0700624 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700625 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
626 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
627 fi
628}
629
Nico Huber234d2462016-01-26 16:10:17 +0100630build_GCC() {
631 if [ "$1" = host ]; then
632 bootstrap_GCC
633 else
634 build_cross_GCC
635 fi
636}
637
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700638build_EXPAT() {
639 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauera344b682016-04-21 19:29:51 -0700640 --prefix=$TARGETDIR || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700641 $MAKE || touch .failed
642 $MAKE install DESTDIR=$DESTDIR || touch .failed
643
644 normalize_dirs
645}
646
647build_PYTHON() {
648 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauera344b682016-04-21 19:29:51 -0700649 || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700650 $MAKE $JOBS || touch .failed
651 $MAKE install DESTDIR=$DESTDIR || touch .failed
652
653 normalize_dirs
654}
655
656build_GDB() {
657 export PYTHONHOME=$DESTDIR$TARGETDIR
658 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
659 LIBDL="-ldl"
660 fi
661 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
662 -lpthread $LIBDL -lutil" \
663 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700664 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700665 --target=${TARGETARCH} --disable-werror --disable-nls
666 $MAKE $JOBS || touch .failed
667 $MAKE install DESTDIR=$DESTDIR || touch .failed
668}
669
670build_IASL() {
671 RDIR=$PWD
672 cd ../$IASL_DIR/generate/unix
673 CFLAGS="$HOSTCFLAGS"
674 HOST="_LINUX"
675 test $UNAME = "Darwin" && HOST="_APPLE"
676 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
677 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Martin Roth6f656132015-12-08 11:14:10 -0700678 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2 -D COREBOOT_TOOLCHAIN_VERSION='\"coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE\"' " CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700679 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
680 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
681}
682
683build_LLVM() {
684 cd ..
685 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
686 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
687 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
688 cd -
689
690 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
Martin Rothfb5647a2015-12-18 09:26:45 -0700691 -DCLANG_VENDOR="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE - " \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700692 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
693 $MAKE $JOBS || touch .failed
694 $MAKE install || touch .failed
695
696 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
697 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
Stefan Reinauere9e6e3d2015-07-07 00:20:42 +0200698
699 # create symlinks to work around broken --print-librt-file-name
700 # when used with -target.
701 cd $DESTDIR$TARGETDIR/lib/clang/${CLANG_VERSION}/lib
702 for i in */libclang_rt.builtins*.a; do
703 ln -s $i .
704 done
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700705}
706
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800707build_MAKE() {
708 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${MAKE_DIR}/configure --prefix=$TARGETDIR \
709 --disable-nls || touch .failed
710 $MAKE $JOBS || touch .failed
711 $MAKE install DESTDIR=$DESTDIR || touch .failed
712
713 normalize_dirs
714}
715
Martin Rothedf965a2015-11-25 16:58:33 -0700716print_stable() {
717 case "$PRINTSTABLE" in
718 AUTOCONF|autoconf) printf "%s\n" "$GCC_AUTOCONF_VERSION";;
719 BINUTILS|binutils) printf "%s\n" "$BINUTILS_VERSION";;
720 CLANG|clang) printf "%s\n" "$CLANG_VERSION";;
721 EXPAT|expat) printf "%s\n" "$EXPAT_VERSION";;
722 GCC|gcc) printf "%s\n" "$GCC_VERSION";;
723 GDB|gdb) printf "%s\n" "$GDB_VERSION";;
724 GMP|gmp) printf "%s\n" "$GMP_VERSION";;
725 IASL|iasl) printf "%s\n" "$IASL_VERSION";;
726 LIBELF|libelf) printf "%s\n" "$LIBELF_VERSION";;
727 MPC|mpc) printf "%s\n" "$MPC_VERSION";;
728 MPFR|mpfr) printf "%s\n" "$MPFR_VERSION";;
729 PYTHON|python) printf "%s\n" "$PYTHON_VERSION";;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800730 MAKE|make) printf "%s\n" "$MAKE_VERSION";;
Martin Rothedf965a2015-11-25 16:58:33 -0700731 *) printf "Unknown tool %s\n" "$PRINTSTABLE";;
732 esac
733}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000734
Zheng Baobb003c82016-08-05 13:41:51 +0800735trap quit 1 2 3 15
736
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000737# Look if we have getopt. If not, build it.
738export PATH=$PATH:.
739getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
740
Stefan Reinauer074d9132009-09-26 16:43:17 +0000741# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700742getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200743if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000744 # Detected GNU getopt that supports long options.
Nico Hubercc414dd2016-09-20 13:59:38 +0200745 args=$(getopt -l version,help,clean,directory:,bootstrap,platform:,languages:,package:,jobs:,destdir:,savetemps,scripting,ccache,supported:,urls,nocolor -o Vhcd:bp:l:P:j:D:tSys:un -- "$@")
Nico Huber78df0bf2016-09-20 14:11:53 +0200746 getopt_ret=$?
Nico Hubercc414dd2016-09-20 13:59:38 +0200747 eval set -- "$args"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000748else
749 # Detected non-GNU getopt
Nico Huber152e78e2016-09-20 15:38:40 +0200750 args=$(getopt Vhcd:bp:l:P:j:D:tSys:un $*)
Nico Huber78df0bf2016-09-20 14:11:53 +0200751 getopt_ret=$?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000752 set -- $args
753fi
754
Nico Huber78df0bf2016-09-20 14:11:53 +0200755if [ $getopt_ret != 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000756 myhelp
757 exit 1
758fi
759
760while true ; do
761 case "$1" in
762 -V|--version) shift; myversion; exit 0;;
763 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100764 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000765 -t|--savetemps) shift; SAVETEMPS=1;;
766 -d|--directory) shift; TARGETDIR="$1"; shift;;
Nico Huber234d2462016-01-26 16:10:17 +0100767 -b|--bootstrap) shift; BOOTSTRAP=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000768 -p|--platform) shift; TARGETARCH="$1"; shift;;
Nico Huberbb313bf2015-09-08 12:30:27 +0200769 -l|--languages) shift; LANGUAGES="$1"; shift;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000770 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000771 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700772 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100773 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100774 -y|--ccache) shift; USECCACHE=1;;
Martin Rothedf965a2015-11-25 16:58:33 -0700775 -s|--supported) shift; PRINTSTABLE="$1"; shift;;
Nico Huber152e78e2016-09-20 15:38:40 +0200776 -u|--urls) shift; printf "%s\n" "$ALL_ARCHIVES"; exit 0;;
777 -n|--nocolor) shift; \
Martin Roth4a53db02016-03-01 15:21:07 -0700778 unset red RED green GREEN blue BLUE cyan CYAN NC;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200779 --) shift; break;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200780 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000781 esac
782done
783
Nico Huberbd74d562016-09-20 14:16:43 +0200784if [ $# -gt 0 ]; then
785 printf "Excessive arguments: $*\n"
786 myhelp
787 exit 1
788fi
789
Martin Rothedf965a2015-11-25 16:58:33 -0700790if [ -n "$PRINTSTABLE" ]; then
791 print_stable
792 exit 0
793fi
794
795#print toolchain builder version string as the header
796printversion
797
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700798case "$TARGETARCH" in
Timothy Pearsona9f62352015-12-30 18:59:00 -0600799 x86_64-elf) ;;
800 x86_64*) TARGETARCH=x86_64-elf;;
801 i386-elf) ;;
802 i386-mingw32) ;;
803 mipsel-elf) ;;
Iru Caiae8e3a02016-04-02 10:50:59 +0800804 riscv-elf) TARGETARCH=riscv64-elf;;
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100805 powerpc64*-linux*) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600806 i386*) TARGETARCH=i386-elf;;
Stefan Reinauer27522ad2016-01-29 17:31:34 -0800807 arm*) TARGETARCH=arm-eabi;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600808 aarch64*) TARGETARCH=aarch64-elf;;
Martin Roth3e0f74d2016-03-08 12:07:04 -0700809 nds32le-elf) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600810 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700811esac
812
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700813# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700814
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700815case "$PACKAGE" in
816 GCC|gcc)
817 echo "Target architecture is now $TARGETARCH"
818 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700819 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700820 ;;
821 GDB|gdb)
822 NAME="${TARGETARCH} cross GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700823 if [ $SKIPPYTHON -eq 0 ]; then
Ronald G. Minnichfb944f42016-02-27 04:06:42 +0000824 PACKAGES="EXPAT PYTHON GDB"
825 else
826 PACKAGES="EXPAT GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700827 fi
828 ;;
829 CLANG|clang)
830 NAME=clang
831 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700832 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700833 ;;
834 IASL|iasl)
835 NAME="IASL ACPI compiler"
836 PACKAGES=IASL
837 ;;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800838 MAKE|make)
839 NAME="GNU Make"
840 PACKAGES=MAKE
841 ;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700842 *)
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800843 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL, MAKE)${NC}\n\n";
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700844 exit 1
845 ;;
846esac
Peter Stugeceacd772011-06-09 04:54:16 +0200847
Stefan Reinauer66e93352015-06-16 22:38:23 +0200848# Find all the required tools:
849
850TAR=$(searchtool tar) || exit $?
851PATCH=$(searchtool patch) || exit $?
852MAKE=$(searchtool make) || exit $?
853SHA1SUM=$(searchtool sha1sum)
zbao5cf758d2015-09-01 22:28:57 -0400854#SHA512SUM=$(searchtool sha512sum)
855#MD5SUM=$(searchtool md5sum)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200856CHECKSUM=$SHA1SUM
Martin Roth95f7b222016-03-20 12:38:48 -0600857LBZIP2=$(searchtool lbzip2 "" nofail)
858PIGZ=$(searchtool pigz "" nofail)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200859
860searchtool m4 > /dev/null
861searchtool bison > /dev/null
862searchtool flex flex > /dev/null
863searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Marc Jones5ee69512015-06-17 15:38:17 -0600864searchtool clang "clang version" nofail > /dev/null || \
Martin Rothe3963172016-01-06 13:54:32 -0700865searchtool clang "LLVM" "" "g++" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200866searchtool wget > /dev/null
867searchtool bzip2 "bzip2," > /dev/null
868
Martin Roth591790f2016-03-20 20:39:04 -0600869check_for_library "-lz" "zlib (zlib1g-dev or zlib-devel)"
870
Nico Huber156d87c2016-09-20 12:59:53 +0200871CC=cc
872check_cc
873
Martin Roth88463822016-01-07 11:03:36 -0700874if [ "$HALT_FOR_TOOLS" -ne 0 ]; then
875 exit 1
876fi
877
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700878# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000879
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700880if [ "$clean" = "1" ]; then
881 cleanup
882fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000883
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700884# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000885
Patrick Georgif2c15f52015-06-11 21:07:31 +0200886if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700887if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000888 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
889
890 # generally the OS X compiler can create x64 binaries.
891 # Per default it generated i386 binaries in 10.5 and x64
892 # binaries in 10.6 (even if the kernel is 32bit)
893 # For some weird reason, 10.5 autodetects an ABI=64 though
894 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700895 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000896 OPTIONS="ABI=64"
897 else
898 OPTIONS="ABI=32"
899 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700900
Stefan Reinauer4266b922012-12-05 16:18:32 -0800901 # In Xcode 4.5.2 the default compiler is clang.
902 # However, this compiler fails to compile gcc 4.7.x. As a
903 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700904 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800905 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700906 fi
zbao11f1d312015-08-05 23:15:54 -0400907elif [ $UNAME = "Linux" -o $UNAME = "Cygwin" ]; then
Patrick Georgiddb8f802015-07-04 17:45:54 +0200908 # gmp is overeager with detecting 64bit CPUs even if they run
909 # a 32bit kernel and userland.
910 if [ "$(uname -m 2>/dev/null)" = "i686" ]; then
911 OPTIONS="ABI=32"
912 fi
Nico Huberde45c592016-01-20 23:22:33 +0100913elif [ $UNAME = "NetBSD" ]; then
914 # same for NetBSD but this one reports an i386
915 if [ "$(uname -m 2>/dev/null)" = "i386" ]; then
916 OPTIONS="ABI=32"
917 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000918fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700919fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000920
Nico Huber5f72f962016-01-31 23:05:19 +0100921export HOSTCFLAGS="-Os"
922if have_hostcflags_from_gmp; then
923 set_hostcflags_from_gmp
924fi
925
Patrick Georgic1a75b12011-11-04 21:37:14 +0100926if [ "$USECCACHE" = 1 ]; then
927 CC="ccache $CC"
928fi
929
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700930# Prepare target directory for building GCC
931# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100932mkdir -p $DESTDIR$TARGETDIR/bin
Stefan Reinauer88352d72016-04-06 15:57:03 -0700933mkdir -p $DESTDIR$TARGETDIR/share
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100934export PATH=$DESTDIR$TARGETDIR/bin:$PATH
935
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700936# Download, unpack, patch and build all packages
937
Martin Roth03625172016-02-17 14:44:14 -0700938printf "Downloading tarballs ... \n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700939mkdir -p tarballs
940for P in $PACKAGES; do
941 download $P
942done
Martin Roth03625172016-02-17 14:44:14 -0700943printf "Downloaded tarballs ... ${green}ok${NC}\n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700944
945printf "Unpacking and patching ... \n"
946for P in $PACKAGES; do
947 unpack_and_patch $P || exit 1
948done
949printf "Unpacked and patched ... ${green}ok${NC}\n"
950
951printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700952for package in $PACKAGES; do
953 build $package
954done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700955printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700956
Stefan Reinauer699ac272015-06-05 12:43:28 -0700957# Adding git information of current tree to target directory
958# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700959PROGNAME=$(basename "$0")
Stefan Reinauer88352d72016-04-06 15:57:03 -0700960rm -f "$DESTDIR$TARGETDIR/share/$PROGNAME-*"
961cp "$PROGNAME" "$DESTDIR$TARGETDIR/share/$PROGNAME-$CROSSGCC_VERSION-$CROSGCC_COMMIT"
Zheng Bao30b895f2013-02-06 18:04:40 +0800962
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700963cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000964
Stefan Reinauer699ac272015-06-05 12:43:28 -0700965printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"